#!/usr/bin/env python

import os
from fileTransferPlugin import FileTransferPlugin

class GridftpFileTransferPlugin(FileTransferPlugin):

    COMMAND = 'globus-url-copy -c -cd -r -vb -tcp-bs 512K -p 1 -sync -sync-level 1'

    def __init__(self, src=None, dest=None, command=COMMAND):
        FileTransferPlugin.__init__(self, command, src, dest)

    def getSrcUrl(self, filePath, dataDirectory):
        if self.src is None:
            srcUrl = 'file://%s' % filePath
        else:
            srcUrl = '%s/%s' % (self.src,filePath)
        return srcUrl
    
    def getDestUrl(self, filePath, dataDirectory, storageHost, storageDirectory):
        dirName = os.path.dirname(os.path.relpath(filePath, dataDirectory)).strip()
        fileName = os.path.basename(filePath)
        destUrl = 'sshftp://%s/%s/%s/%s' % (storageHost, storageDirectory, dirName, fileName)
        return destUrl

#######################################################################
# Testing.
if __name__ == '__main__':
    ft = GridftpFileTransferPlugin('/tmp/xyz', '/tmp/xyz2')
    ft.start()
    print 'StdOut: ', ft.getStdOut()
    print 'StdErr: ', ft.getStdErr()
    print 'Exit Status: ', ft.getExitStatus()
